﻿/* mega328pb LED + UART0+UART1+UART2
 * мигание светодиодами LED1 и LED2; выдача сообщения в UART0, UART1 и UART2
 * Создан: 1 марта 2018
 * Автор : AS-kit */ 

#define F_CPU	14745600UL

#include <avr/io.h>
#include <util/delay.h>

#define LED0 (1<<5)
#define LED1 (1<<6)

#define BUAD	115200
#define BRC		((F_CPU/16/BUAD) - 1)  

int main(void)
{	
	DDRD  |= (LED0 | LED1);
	PORTD |= LED0;
	PORTD &= ~LED1;
	
	UBRR0H = (unsigned char) (BRC >> 8);  // порт UART0, скорость 115200 бод
	UBRR0L = (unsigned char) BRC; // значение BRC = 7 для установки скорости 1X    
	UCSR0B = (1 << TXEN);   
	UCSR0C = (1 << USBS) | (1 << UCSZ1) | (1 << UCSZ0); // 8-бит, нет паритета, 1 стоп-бит
	
	UBRR1H = (unsigned char) (BRC >> 8);  // порт UART1, скорость 115200 бод
	UBRR1L = (unsigned char)  BRC; 
	UCSR1B = (1 << TXEN);
	UCSR1C = (1 << USBS) | (1 << UCSZ1) | (1 << UCSZ0); 
	
	UBRR2H = (unsigned char) (BRC >> 8);  // порт UART2, скорость 115200 бод
	UBRR2L = (unsigned char)  BRC; 
	UCSR2B = (1 << TXEN);
	UCSR2C = (1 << USBS) | (1 << UCSZ1) | (1 << UCSZ0); 
		
	    while(1)
    {
		UDR0 = 'U'; // вывод двух символов в порт UART0
		UDR0 = '2';  
			UDR1 = 'U'; // вывод двух символов в порт UART1
			UDR1 = '1';
				UDR2 = 'U'; // вывод двух символов в порт UART2
				UDR2 = '2';
		 PORTD ^= (LED0 | LED1); // мигание светодиодами LED1 и LED2
		_delay_ms(1000);
    }
}


